<?php

namespace Ems\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;

class CertisignRepository {
    /** @var Connection */
    protected $connection;

    public function __construct(
        EntityManager $entityManager
    ) {
        $this->connection = $entityManager->getConnection();
    }

    public function setDocumentAsRejected(
        array $params
    ) {
        $sql = <<<SQL
            UPDATE GPE_INTELETRDIGIT
            SET
                DTREJEICAO = SYSDATE,
                DTREJEICAO = :P_DSREJEICAO
            WHERE
                NRPARCNEGOCIO = :P_NRPARCNEGOCIO AND
                DSIDDOCUMENTO = :P_IDDOCUMENTO AND
                NRORG = :P_NRORG
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function setDocumentAsSigned(
        array $params
    ) {
        $sql = <<<SQL
            UPDATE GPE_INTELETRDIGIT
            SET
                DTASSINATURA = SYSDATE,
                IDSTATUS = 'S'
            WHERE
                NRPARCNEGOCIO = :P_NRPARCNEGOCIO AND
                DSIDDOCUMENTO = :P_IDDOCUMENTO AND
                NRORG = :P_NRORG
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}