<?php
namespace Ems\Util;

class Base64Util {
    public const B64_TABLE = [
        'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
        'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
        'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
        'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
        '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/',
    ];

    public static function base64IndexToChar(
        string $char
    ) {
        $index = strrpos(self::B64_TABLE, $char);
        return $index;
    }

    public static function charToBase64Index(
        int $index
    ) {
        $char = self::B64_TABLE[$index];
        return $char;
    }

    public static function base64IndexToB64Binary(
        int $index
    ) {
        $binary = decbin($index);
        $binary6Bits = str_pad($binary, 6, '0', STR_PAD_LEFT);

        return $binary6Bits;
    }

    public static function b64BinaryArrayToByteArray(
        array $b64BinaryArray
    ): array {
        $implodedB64Bits = implode($b64BinaryArray);
        $bytes = str_split($implodedB64Bits, 8);

        $countBytes = count($bytes);
        $lastByte = $bytes[$countBytes - 1];

        if ($lastByte) {
            $bytes[$countBytes - 1] = str_pad($lastByte, 8, '0');
        }

        return $bytes;
    }

    public static function stringToByteArray(
        string $str
    ): array {
        $byteArray = [];
        $characters = str_split($str);

        foreach($characters as $char) {
            $asciiCode = ord($char);
            $byteArray[] = $asciiCode;
        }

        return $byteArray;
    }

    public static function base64ToByteArray(
        string $base64
    ): array {
        $decoded = base64_decode($base64);
        $byteArray = self::stringToByteArray($decoded);

        return $byteArray;
    }
}
